//----------------------------------------------------------------
//  Time-stamp:	<00/11/26 15:22 mjs>
//
//				YOUR NAME HERE!!!
//
//	File:		map.h
//	Purpose:	Specify a map of students via a BST
//----------------------------------------------------------------

#ifndef _MAP_H
#define _MAP_H

#include <iostream>
#include "student.h"
using namespace std;


class Map
{
	public:
		Map();

		// Do these 3 AFTER everything else works!!
		Map(const Map &m);		// copy constructor
		~Map();					// destructor
		const Map& operator=(const Map &rhs);	// assignment operator

		Student& operator[](const string &key);
		void Remove(const string &key);
		
		bool InDomain(const string& key)  const;
		void PrintDomain(ostream &os)  const;
		// implement this with an inorder traversal
		
		friend ostream& operator<<(ostream &os, const Map &m);
		// implement this with a level-order traversal


	private:
		struct Pair
		{
			string key;
			Student association;
		};
		
		struct Tree
		{
			Pair data;
			Tree* left;
			Tree* right;
		};
		
		Tree* myRoot;
		
		void MakeEmpty(Tree* &root);
		// Declare any other helper functions you need below...
};

#endif
